Subject: Re: Git for structured data

From: Cedric Sodhi <[email-masked]>
Date: Sat, 6 Dec 2025 19:47:07 +0100

On Sat, Dec 06, 2025 at 05:27:11PM +0100, René Scharfe wrote:
> Did you consider Data Version Control (https://dvc.org/) or Dolt
> (https://github.com/dolthub/dolt)?  Not a recommendation, since I
> haven't used them myself, but they match your description and call
> themselves "Git for data".
> 
> René

Hello and thank you for the two suggestions. I've read up on them and came to the following understanding. But first, I would like to mention that by "data" that needs to be versioned, I was not referring to binary (opaque) data, but rather exactly the type of data which Git currently manages ("source code", in a sense); but in a structured form. Think text or sourcecode fragments in an SQL database.

DVC, although different, seems to be similar to GitLFS and its focus on managing large, opaque data (binary blobs) as opposed to small, transparent data (textfiles). Essentially, it is meant to overcome Git's lack of performance with large files. I therefore think that it does not match my goal.

Dolt appears to fit the functional description. But while it expose a Git-like CLI, it seems to be neither based on Git, nor derived from it. Also, its software architecture is largely monolithic as it bundles its own SQL server, which is makes two-fold dependend on foreign code (Git for the interface, SQL for the database).

Cedric